#!/usr/bin/env node

const bin = require('.')
const path = require('path')
const fs = require('fs')
const yargs = require('yargs') // eslint-disable-line
  .command('install', '安装全部依赖', ({ argv }) => {
    var file = path.join(process.cwd(), 'package.json')
    var pack = require(file)
    pack.binDependencies = pack.binDependencies || {}
    console.log('正在安装二进制依赖... 请稍等~')
    let mods = argv._.map(name => name.split('@')).filter(name => name.length === 2)
    if (mods.length) {
      Promise.all(mods.map(name => bin(Object.assign(argv, { name: name[0], version: name[1] }))))
        .then(() => (pack.binDependencies = Object.assign(
          pack.binDependencies,
          mods.reduce((p, v) => (p[v[0]] = v[1]) && p, {})
        )) &&
          new Promise((resolve, reject) => fs.writeFile(file, JSON.stringify(pack, null, 2), err => err ? reject(err) : resolve())))
        .then(() => console.log(mods.length + ' 个模块已安装完成'))
        .catch(console.error)
    } else {
      mods = Object.entries(pack.binDependencies)
      Promise.all(mods.map(([name, version]) => bin(Object.assign(argv, { name, version }))))
        .then(() => console.log(mods.length + ' 个模块已安装完成'))
        .catch(console.error)
    }
  })
  .argv
